package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.UserRoleDatas;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleDatasSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<UserRoleDatas> selectCond;
	private JSONObject customsearchval;
	public UserRoleDatasSearchFilter(){
		this.page =new Page<UserRoleDatas>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<UserRoleDatas>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_userroledataid_eq;

	public void setN_userroledataid_eq(String n_userroledataid_eq) {
        this.n_userroledataid_eq = n_userroledataid_eq;
        if(!StringUtils.isEmpty(this.n_userroledataid_eq)){
            this.selectCond.eq("userroledataid", n_userroledataid_eq);
        }
    }
	private String n_userroledataname_eq;

	public void setN_userroledataname_eq(String n_userroledataname_eq) {
        this.n_userroledataname_eq = n_userroledataname_eq;
        if(!StringUtils.isEmpty(this.n_userroledataname_eq)){
            this.selectCond.eq("userroledataname", n_userroledataname_eq);
        }
    }
	private String n_userroledataname_like;

	public void setN_userroledataname_like(String n_userroledataname_like) {
        this.n_userroledataname_like = n_userroledataname_like;
        if(!StringUtils.isEmpty(this.n_userroledataname_like)){
            this.selectCond.like("userroledataname", n_userroledataname_like);
        }
    }
	private String n_userroledatasname_like;

	public void setN_userroledatasname_like(String n_userroledatasname_like) {
        this.n_userroledatasname_like = n_userroledatasname_like;
        if(!StringUtils.isEmpty(this.n_userroledatasname_like)){
            this.selectCond.like("userroledatasname", n_userroledatasname_like);
        }
    }
	private String n_userroleid_eq;

	public void setN_userroleid_eq(String n_userroleid_eq) {
        this.n_userroleid_eq = n_userroleid_eq;
        if(!StringUtils.isEmpty(this.n_userroleid_eq)){
            this.selectCond.eq("userroleid", n_userroleid_eq);
        }
    }
	private String n_userrolename_eq;

	public void setN_userrolename_eq(String n_userrolename_eq) {
        this.n_userrolename_eq = n_userrolename_eq;
        if(!StringUtils.isEmpty(this.n_userrolename_eq)){
            this.selectCond.eq("userrolename", n_userrolename_eq);
        }
    }
	private String n_userrolename_like;

	public void setN_userrolename_like(String n_userrolename_like) {
        this.n_userrolename_like = n_userrolename_like;
        if(!StringUtils.isEmpty(this.n_userrolename_like)){
            this.selectCond.like("userrolename", n_userrolename_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLEDATAS_USERROLEDATA_USERROLEDATAID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_userroledataid_eq("NA");
			}
			else{
				this.setN_userroledataid_eq(strParentkey);
			}
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLEDATAS_USERROLE_USERROLEID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_userroleid_eq("NA");
			}
			else{
				this.setN_userroleid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("userroledatasname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}